=begin
#Platform external API.

#Documentation of our Platform external API.

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.34
=end

require 'date'

module Shippo
  class UserParcelTemplateRequestBodyWrapper
    # The measure unit of the package dimensions in inches, cm, or mm. Required, but if using a preset carrier template then this field must be empty
    attr_accessor :distance_unit

    # The height of the package, in units specified by the distance_unit attribute. Required, but if using a preset carrier template then this field must be empty
    attr_accessor :height

    # The length of the package, in units specified by the distance_unit attribute. Required, but if using a preset carrier template then this field must be empty
    attr_accessor :length

    # The name of the User Parcel Template
    attr_accessor :name

    # The object representing the carrier parcel template, if the template was created from a preset carrier template. Otherwise null.
    attr_accessor :template

    # The weight of the package, in units specified by the weight_unit attribute.
    attr_accessor :weight

    # The weight unit of the package, as lb, g, kg, or oz.
    attr_accessor :weight_unit

    # The width of the package, in units specified by the distance_unit attribute. Required, but if using a preset carrier template then this field must be empty
    attr_accessor :width

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'distance_unit' => :'distance_unit',
        :'height' => :'height',
        :'length' => :'length',
        :'name' => :'name',
        :'template' => :'template',
        :'weight' => :'weight',
        :'weight_unit' => :'weight_unit',
        :'width' => :'width'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'distance_unit' => :'Object',
        :'height' => :'Object',
        :'length' => :'Object',
        :'name' => :'Object',
        :'template' => :'Object',
        :'weight' => :'Object',
        :'weight_unit' => :'Object',
        :'width' => :'Object'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end
  
    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Shippo::UserParcelTemplateRequestBodyWrapper` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Shippo::UserParcelTemplateRequestBodyWrapper`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'distance_unit')
        self.distance_unit = attributes[:'distance_unit']
      end

      if attributes.key?(:'height')
        self.height = attributes[:'height']
      end

      if attributes.key?(:'length')
        self.length = attributes[:'length']
      end

      if attributes.key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.key?(:'template')
        self.template = attributes[:'template']
      end

      if attributes.key?(:'weight')
        self.weight = attributes[:'weight']
      end

      if attributes.key?(:'weight_unit')
        self.weight_unit = attributes[:'weight_unit']
      end

      if attributes.key?(:'width')
        self.width = attributes[:'width']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @distance_unit.nil?
        invalid_properties.push('invalid value for "distance_unit", distance_unit cannot be nil.')
      end

      if @height.nil?
        invalid_properties.push('invalid value for "height", height cannot be nil.')
      end

      if @length.nil?
        invalid_properties.push('invalid value for "length", length cannot be nil.')
      end

      if @name.nil?
        invalid_properties.push('invalid value for "name", name cannot be nil.')
      end

      if @width.nil?
        invalid_properties.push('invalid value for "width", width cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @distance_unit.nil?
      distance_unit_validator = EnumAttributeValidator.new('Object', ['cm', 'in', 'ft', 'm', 'mm', 'yd'])
      return false unless distance_unit_validator.valid?(@distance_unit)
      return false if @height.nil?
      return false if @length.nil?
      return false if @name.nil?
      weight_unit_validator = EnumAttributeValidator.new('Object', ['g', 'kg', 'lb', 'oz'])
      return false unless weight_unit_validator.valid?(@weight_unit)
      return false if @width.nil?
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] distance_unit Object to be assigned
    def distance_unit=(distance_unit)
      validator = EnumAttributeValidator.new('Object', ['cm', 'in', 'ft', 'm', 'mm', 'yd'])
      unless validator.valid?(distance_unit)
        fail ArgumentError, "invalid value for \"distance_unit\", must be one of #{validator.allowable_values}."
      end
      @distance_unit = distance_unit
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] weight_unit Object to be assigned
    def weight_unit=(weight_unit)
      validator = EnumAttributeValidator.new('Object', ['g', 'kg', 'lb', 'oz'])
      unless validator.valid?(weight_unit)
        fail ArgumentError, "invalid value for \"weight_unit\", must be one of #{validator.allowable_values}."
      end
      @weight_unit = weight_unit
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          distance_unit == o.distance_unit &&
          height == o.height &&
          length == o.length &&
          name == o.name &&
          template == o.template &&
          weight == o.weight &&
          weight_unit == o.weight_unit &&
          width == o.width
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [distance_unit, height, length, name, template, weight, weight_unit, width].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        elsif attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        end
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        Shippo.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end  end
end
